

Handle_PreGame()
{
	if(g_iGameMode == GAME_PREGAME)
		return;
		
	if( g_bTournamentMode )
	{
		if( PlayersReady() )
		{
			g_iCountdownTimer = get_pcvar_num( P_COUNTDOWNTIME );
			
			BeginCountdown(random_num(1,2));
			g_iGameMode = GAME_PREGAME;	
			format(g_HudMsg3, 127, "" );
		}
		return;
	}
	
	
	if(CanStartGame())
	{
		g_iCountdownTimer = get_pcvar_num( P_COUNTDOWNTIME );
		BeginCountdown(random_num(1,2));
		g_iGameMode = GAME_PREGAME;
		format(g_HudMsg3, 127, "" );
	}
}

bool:CanStartGame()
{
	new id, cnt, team;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(is_user_alive(id))
		{
			team = get_user_team(id);
			if((team == 1 || team == 2))// && HasClass(id))
				cnt++;	
		}
	}
	
	if(cnt >= get_pcvar_num(P_PLAYERSNEEDED))
		return true;
		
	return false;
}

bool:PlayersReady()
{
	new id, team//teamready[TEAMS][512], teamLen[TEAMS]
	new player_name[32], teamcount[TEAMS], readycount[TEAMS]
	
	new len;
	len += format( g_HudMsg2[len], 1023-len, "Not Ready^n" );
	len += format( g_HudMsg2[len], 1023-len, "----------^n^n^n" );
	for(id = 1; id<=g_iMaxplayers; id++)
		if(is_user_connected(id) && !is_user_bot(id)) {
			team = get_user_team(id)
			
			teamcount[team]++
			
			if(team != T || team != CT)
				continue;
				
			if(Ready[id]) {
				readycount[team]++
				//teamLen[team] += format(teamready[team][teamLen[team]], 511-teamLen[team], "(READY) %s^n", player_name)	
			}
			else 
			{
				get_user_name(id, player_name, 31)
				len += format( g_HudMsg2[len], 1023-len, "%s^n", player_name );
				//teamLen[team] += format(teamready[team][teamLen[team]], 511-teamLen[team], "(WAITING) %s^n", player_name)	
			}
			
		}
		
	
	new required = get_pcvar_num(P_PLAYERS)
	/*
	new missing[64], x
					
	for(x=1;x<3;x++) {
			
		if(teamcount[x] < required)
			format(missing, 63, "Players Missing: %i", required-teamcount[x])
		else if(teamcount[x] != readycount[x])
			format(missing, 63, "Players Not Ready: %i", teamcount[x]-readycount[x])
		else if(teamcount[x] == readycount[x])
			format(missing, 63, "READY")
			
		set_hudmessage(x==1?255:25, 10, x==1?25:255, 0.60, x==1?0.2:0.55, 0, 1.0, 1.5, 0.1, 0.1, x==1?CHANNEL1:CHANNEL3)
		show_hudmessage(0,"%s(TEAM %s)  %s^n%s", x==1?"- Pre-Game^n^n":"" ,TeamNames[x], missing, teamready[x])
	}
	*/
	if( (teamcount[T] >= required && teamcount[CT] >= required) && 
		(teamcount[T] == readycount[T] && teamcount[CT] == readycount[CT]) ) 
	{
		return true;
	}	
	return false;
}

public BeginCountdown(team) {
	static pteam = 0;
	
	if(g_iCountdownTimer <= 0) 
	{
		ChangePossession(pteam);
		REFEREE( GAME_START );

		return;
	}

	g_iCountdownTimer--;
	set_task(1.0,"BeginCountdown",TASK_COUNTDOWN);
		
	if(team != 9999)
		pteam = team;
				
	client_print(0,print_center, "%s will receive the ball.", pteam==2?"Terrorist":"Counter-Terrorist" );
	
	new Float:ctime = get_pcvar_float( P_COUNTDOWNTIME );
	new output[32]
	num_to_word(g_iCountdownTimer,output,31)
	client_cmd(0,"spk vox/%s.wav",output)
	
	if(g_iCountdownTimer > (ctime / 2))
		set_hudmessage(20, 250, 20, -1.0, 0.55, 1, 1.0, 1.0, 1.0, 0.5, CHANNEL3)
	else
		set_hudmessage(255, 0, 0, -1.0, 0.55, 1, 1.0, 1.0, 1.0, 0.5, CHANNEL3) 	
		
	if(g_iCountdownTimer > (ctime - 5))
		show_hudmessage(0, "GAME BEGINS IN...^n%i",g_iCountdownTimer)
	else
		show_hudmessage(0, "%i",g_iCountdownTimer)
}