

Class_StartPlay()
{
	new ballteam = GetBallData( BALL_TEAM );
	new oteam = ballteam == 1 ? 2 : 1;
	
	if(g_iPlay == PLAY_STANDARD)
		SetSpecialClass(ballteam, CLASS_QUARTERBACK);
	else 
		SetSpecialClass(ballteam, CLASS_KICKER);	
		
	SetSpecialClass(oteam, CLASS_SAFETY);
	
	Class_ChooseSpecial(false);
}

Class_EndPlay()
{
	//Manage our special classes.
	//Class_Positions();	
	new ballteam = GetBallData( BALL_TEAM );
	new oteam = ballteam == 1 ? 2 : 1;
	
	
	if(g_iPlay == PLAY_STANDARD)
		SetSpecialClass(ballteam, CLASS_QUARTERBACK);
	else 
		SetSpecialClass(ballteam, CLASS_KICKER);	
		
	SetSpecialClass(oteam, CLASS_SAFETY);
	
	Class_ChooseSpecial(true);
}

Class_ChooseSpecial(bool:bIsEndPlay)
{
	new ballteam = GetBallData( BALL_TEAM );
	new oteam = ballteam == 1 ? 2 : 1;
	
	new ballSpecial = GetSpecialClass(ballteam);
	new oSpecial = GetSpecialClass(oteam);
	//if(g_bTournamentMode) 
	{
		//Tournament_ChooseSpecial( ballteam, ballSpecial, bIsEndPlay );
		//Tournament_ChooseSpecial( oteam, oSpecial, bIsEndPlay );
	}
	//else
	{
		Public_ChooseSpecial( ballteam, ballSpecial, bIsEndPlay );	
		Public_ChooseSpecial( oteam, oSpecial, bIsEndPlay );	
	}
			
}

//Class_PlayerSpawn(id)
//{
//	
//}

Class_PlayerDisconnect(id)
{
	ClearPlayer(id);
}

//Class_PlayerLeftSpecial( team, class )
//{
//	
//}

ClearPlayer(id)
{
	Ready[id] = false;
		
	SetClass(id, 0);
	ClearSignup( id );
	RemovePlayer(id, 1);
	RemovePlayer(id, 2);
}

CountSpecialSignup(team,class)
{
	return g_iSpecialListCnt[team][class];
}
CountClass(team,class)
{
	new id, pteam, count;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(!is_user_connected(id))
			continue;
		pteam = get_user_team(id);
		if(pteam == team && g_iClass[id] == class)
			count++;
	}	
	return count;
}

GetDefaultClass(id)
{
	return g_iClass[id];
}
	
GetClass(id)
{
	if(!is_user_connected(id))
		return 0;
		
	new team = get_user_team(id);
	if(team != 1 && team != 2)
		return 0;
		
	new specialclass = GetSpecialClass(team);
	new curspecial = GetCurrentSpecial(team,specialclass);
	if(curspecial == id)
		return specialclass;

	return g_iClass[id];	
}

SetClass(id, class)
{
	g_iClass[id] = class;
}


GetSignup( id, class )
{
	if(g_iSpecialSignup[id] & (1<<class))
		return 1;
	return 0;
}

ClearSignup( id )
{
	g_iSpecialSignup[id] = 0;
}

SetCurrentSpecial( id, team, class )
{
	g_iSpecial[team][class] = id;	
}
GetCurrentSpecial( team, class )
{
	return g_iSpecial[team][class];	
}

/*
GetSpecialListPos(team, class)
{
	return g_iSpecialListPos[team][class];
}
*/

ChangeSpecial(team, class)
{
	new pos = ++g_iSpecialListPos[team][class];
	new cnt = g_iSpecialListCnt[team][class];
	if(pos >= cnt)
	{
		pos = 0;
		g_iSpecialListPos[team][class] = 0;
	}
		
	new id = g_iSpecialList[team][class][pos];
	g_iSpecial[team][class] = id;
	return id;
}

//Special class is determined by play and team.
SetSpecialClass(team, class)
{
	g_iSpecialClass[team] = class;	
}

GetSpecialClass(team)
{
	return g_iSpecialClass[team];	
}

AddPlayer(id, team, class)
{
	if(id < 1 || id > g_iMaxplayers)
		return;
		
	if(team != 1 && team != 2)
		return;
	//Remove us from the list if we're on it already.
	RemovePlayer(id,team,class); 
	g_iSpecialSignup[id] |= (1<<class)
	
	new cnt = g_iSpecialListCnt[team][class];
	g_iSpecialList[team][class][cnt] = id;
	g_iSpecialListCnt[team][class]++;
}

RemovePlayer(id, team, class=-1)
{
	if(id < 1 || id > g_iMaxplayers)
		return;
		
	if(team != 1 && team != 2)
		return;
		
	if(class == -1)	{
		for(class=0;class<CLASS_COUNT;class++)
			RemoveFromList( id, team, class );
	}
	else
		RemoveFromList( id, team, class );
}

RemoveFromList( id, team, class )
{
	g_iSpecialSignup[id] &= ~(1<<class);
	if(GetCurrentSpecial(team,class) == id)
	{
		SetCurrentSpecial(0, team, class);
		//Class_PlayerLeftSpecial( team, class );
	}
				
	new i, x;
	new cnt = g_iSpecialListCnt[team][class];
	for(i=0;i<cnt;i++)
		if(g_iSpecialList[team][class][i] == id)
		{
			g_iSpecialListCnt[team][class]--;
			//--cnt;
			for(x=i;x<cnt;x++)
				g_iSpecialList[team][class][x] = g_iSpecialList[team][class][x+1];	
		}	
		
	
}

Class_CreateMenus()
{
	CreatePublicClassMenu();
	CreatePublicSpecialMenu();	
}

/*
Class_Positions()//Handle_ClassPositions()
{
	//if(!g_bTournamentMode)
		Public_Positions();
	//else
	//	Tournament_Positions();
}

Class_NeedSpecial(id, team)
{
	//if(!g_bTournamentMode)
		Public_NeedSpecial(id, team);
	//else
	//	Tournament_NeedSpecial(id, team);
}

Tournament_NeedSpecial(id, team)
{
	
}

Tournament_Positions()
{
}

Tournament_ChangeClass(id)
{
	
}

Pug_SwitchClass( team, class )
{
		
}


SkipPlayer( id, class )
{
	g_bSkip[id][class] = true;
}
*/
public client_connect(id)
{
	g_iPlayerTeam[id] = 0;
	g_IsFirstSpawn[id] = false;	
	g_iChoosingClass[id] = false;
}

public client_disconnect(id)
{
	Class_PlayerDisconnect(id)
	
	new holder = GetBallData( BALL_HOLDER );
	if(holder == id)
	{
		if(g_bPlayClockOn)
			Football_Dead( g_flCurrentYard, false );
		else
			Football_Fumble();
	}
	Handle_Disconnect(id);
}

public cmdChangePosition(id)
{
	if(IsPlayClockOn())
		ChangeSpawnPosition( id );
	return PLUGIN_HANDLED;
}

public cmdChangeClass(id)
{
	g_iChoosingClass[id] = false;
	
	//if(g_bTournamentMode)
	//	Tournament_ChangeClass(id);
	//else
	Public_ChangeClass(id);
	return PLUGIN_HANDLED;
}



/*
bool:IsPlayerClass( id, class )
{
	return (g_iPlayerClass[id] & (1<<class)) > 0;
}

GetClassCount( team, class )
{
	return g_iClassCount[team][class];	
}

GetClass( id )
{
	return g_iPlayerCurrentClass[id];	
}

SetClass( id )
{
	new pclass = g_iPlayerClass[id];
	new class;
	for(class=CLASS_RECEIVER;class<=CLASS_LINEMAN;class++)
		if( pclass & (1<<class) )
		{
			g_iPlayerCurrentClass[id] = class;	
			break;
		}
	
}

GetCurrentSpecials( &quarterback, &kicker, &safety )
{
	new id;
	new class;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		class = GetClass(id);
		if(class == CLASS_QUARTERBACK)
		{
			quarterback = id;
			continue;
		}
		if(class == CLASS_KICKER)
		{
			kicker = id;
			continue;
		}
		if(class == CLASS_SAFETY)
		{
			safety = id;
			continue;
		}
	}	
}

AddClass( id, team, class )
{
	if(g_iPlayerClass[id] & (1<<class) == 0)
	{
		g_iPlayerClass[id] |= (1<<class);	
		g_iClassCount[team][class]++;
		
		if(class >= CLASS_QUARTERBACK)
		{
			Roster_AddPosition( id, team, class-CLASS_QUARTERBACK );	
		}
	}
}

RemoveClass( id, team, class )
{
	if(g_iPlayerClass[id] & (1<<class) > 0)
	{
		g_iPlayerClass[id] &= ~(1<<class);	
		g_iClassCount[team][class]--;
		
		if(class >= CLASS_QUARTERBACK)
			Roster_ClearPosition( id, team, class-CLASS_QUARTERBACK );
	}
}

Class_BeginPlay()
{
	new startTeam = GetBallData( BALL_START_TEAM );
	new id, team;
	new oTeam = startTeam == 1 ? 2 : 1;
	
	
	//Public_NeedSpecial(0, startTeam);
	
	
	new qb = GetSpecial( startTeam, CLASS_QUARTERBACK );
	new safety = GetSpecial( oTeam, CLASS_SAFETY );
	new kicker = GetSpecial( startTeam, CLASS_KICKER );
	new name[32];
	
	if(g_iPlay == PLAY_STANDARD)
	{
		if(!qb || !is_user_connected(qb))
		{
			qb = Roster_ChangePosition( startTeam, __QUARTERBACK );
			if(!qb)
			{
				new special = Roster_RandomPosition(startTeam);
				g_iPlayerCurrentClass[ special ] = CLASS_QUARTERBACK;	
			}
		}
	}
	else
	{
		if(!kicker || !is_user_connected(kicker))
		{
			kicker = Roster_ChangePosition( startTeam, __KICKER );
			if(!kicker)
			{
				new special = Roster_RandomPosition(startTeam);
				g_iPlayerCurrentClass[ special ] = CLASS_KICKER;		
			}
		}
	}
	
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(g_iPlayerClass[id] == 0)
			continue;
			
		team = get_user_team(id);
		if(startTeam == team)
		{
			if(g_iPlay == PLAY_STANDARD)
			{
				if(id != qb)
				{
					SetClass(id);
				}
				else
				{
					g_iPlayerCurrentClass[id] = CLASS_QUARTERBACK;
					get_user_name(id,name,31);
					client_print(0,print_chat,"%s is quarterback.", name );	
				}
			}
			else 
			{
				if(id != kicker)
				{
					SetClass(id);
				}
				else
				{
					get_user_name(id,name,31);
					client_print(0,print_chat,"%s is kicker.", name );	
					g_iPlayerCurrentClass[id] = CLASS_KICKER;
				}
			}
		}
		else
		{
			if(id != safety)
				SetClass(id);
			else
				g_iPlayerCurrentClass[id] = CLASS_SAFETY;
		}
	}
}

Public_Positions()
{
	new startTeam = GetBallData( BALL_START_TEAM );
	new ballTeam = GetBallData( BALL_TEAM );
	new oTeam = ballTeam == 1 ? 2 : 1;
	
	new qb, safety, kicker;
	GetCurrentSpecials( qb, kicker, safety );
	
	if(g_iPlay == PLAY_STANDARD)
	{
		//new qb = GetSpecial( ballTeam, CLASS_QUARTERBACK );
		new Float:gained;
		
		if(ballTeam == startTeam)
			gained = g_flCurrentBallYard - g_flCurrentYard;//g_flStartYard[startTeam];
			
		new bool:passFailed = (g_iLastEvent == PENALTY_DELAYOFGAME || g_iLastEvent == PASS_CATCH_OUTOFBOUNDS || g_iLastEvent == PASS_INCOMPLETE || g_iLastEvent == PASS_OUTOFBOUNDS);
		
		//Change our quarterback if we failed.
		if(passFailed || !is_user_connected(qb) || gained < 1.0 || (g_bExtraPoint && g_iLastEvent != SCORE_TWOPOINT))
			Roster_ChangePosition( ballTeam, __QUARTERBACK );
	}
	else 
	{
		//new kicker = GetSpecial( ballTeam, CLASS_KICKER );
		//Change our Kicker only if he didn't score a FG.
		if(!is_user_connected(kicker) || (g_iLastEvent != SCORE_FIELDGOAL && g_iLastEvent != SCORE_EXTRAPOINT) )
			Roster_ChangePosition( ballTeam, __KICKER );
	}	
	
	//new safety 	= GetSpecial( oTeam, CLASS_SAFETY );
	if(!is_user_connected(safety) || g_iLastEvent != PENALTY_DELAYOFGAME)
		Roster_ChangePosition( oTeam, __SAFETY );
}

Public_NeedSpecial(id, team)
{
	
}

Roster_AddPosition( id, team, class )
{
	new count = g_iRosterCount[team][class];
	
	//We start from 1, so zero will be nobody.
	if(count == 0)
		g_iCurrentSpecial[team][class] = 0;
		
	g_iSpecialRoster[team][class][count] = id;
	g_iRosterCount[team][class]++;
}

Roster_ChangePosition( team, class )
{
	new count = g_iRosterCount[team][class];
	//if(count == 0)
	//	return 0;
		
	new curSpecial = g_iCurrentSpecial[team][class];
	//new oldspecial = g_iSpecialRoster[team][class][curSpecial];
	
	//SetClass(oldspecial);
	new special = g_iSpecialRoster[team][class][curSpecial];
	new x;
	for(x=0;x<5;x++)
	{
		curSpecial++;
		
		if(curSpecial >= count)
			curSpecial = 0;
				
		special = g_iSpecialRoster[team][class][curSpecial];
		if(is_user_connected(special))
		{
			g_iCurrentSpecial[team][class] = curSpecial;
			break;
		}
	}
	return special;
}

GetSpecial( team, class )
{
	class -= CLASS_QUARTERBACK;
		
	new curSpecial = g_iCurrentSpecial[team][class];
	new special = g_iSpecialRoster[team][class][curSpecial];
	return special;//g_iSpecialTeam[team][class];	
}

Roster_ClearPosition( id, team, class )//, startPos )
{
	new special, pos;
	new count = g_iRosterCount[team][class];
	new temp, temp2;
	for(pos=0;pos<count;pos++)
	{
		special = g_iSpecialRoster[team][class][pos];
		if( special == id )
		{
			g_iSpecialRoster[team][class][pos] = 0;
			
			temp = pos+1;
			
			while(temp < (count-1))
			{
				temp2 = temp+1;
				
				g_iSpecialRoster[team][class][temp] = g_iSpecialRoster[team][class][temp2];
				g_iSpecialRoster[team][class][temp2] = 0;
				temp++;
			}
		
			if(count > 0)
				g_iRosterCount[team][class]--;
			else
				g_iRosterCount[team][class] = 0;
				
			break;
		}
	}
}

Roster_Count(team,class)
{
	return g_iRosterCount[team][class];
}

Roster_RandomPosition(team)
{
	new id, pteam;
	new plist[33], num;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if( is_user_connected(id) )
		{
			pteam = get_user_team(id);//g_iPlayerTeam[id];
			if(pteam == team && g_iPlayerClass[id] > 0 )
				plist[num++] = id;
		}
	}
	return plist[ random_num(0,num-1) ];	
}

ClearPlayer(id, team=1)
{
	//Loop through classes to make sure our count stays accurate.

	new class;
	for(team=T;team<=CT;team++)
	{
		for(class=CLASS_RECEIVER;class<CLASS_COUNT;class++)
			RemoveClass( id, team, class );
		g_iPlayerCurrentClass[id] = 0;
	
		Roster_ClearPosition( id, team, __QUARTERBACK );
		Roster_ClearPosition( id, team, __SAFETY );
		Roster_ClearPosition( id, team, __KICKER );
	}
	RemoveReserved( id );
}
*/


/*

ChooseTournamentClasses(id)
{
	new team = get_user_team(id);
	if(team != 1 && team != 2)
		return;
		
	menu_display(id, g_iTournamentClass, 0)	
}

public TournamentClassHandler( id, menu, item )
{
	if(item == MENU_EXIT)
		return;
	if(!is_user_connected(id))
		return;
		
	new team = get_user_team(id);
	if(team != 1 && team != 2)
		return;
		
	new cmd[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback); 
	
	new class = str_to_num(cmd);
	
	if(class == 20)
		return;
	if(class == 15)
		ClearPlayer(id);
		
	if( g_iPlayerTournmanet[team][class] > 0 )
	{
		client_print(id,print_chat, "That Position has been filled." );	
		ChooseTournamentClasses(id);
	}
	else
	{
		g_iPlayerTournmanet[team][class] = id;
		switch(class)
		{
			case 0:
			{
				g_iSpecialSignup[id] = (1<<QUARTERBACK) | (1<<SAFETY);
				g_iPlayerClass[id] = WIDERECEIVER;
			}
			case 1:
			{
				g_iPlayerClass[id] = OFFENSE_LINEMAN;
				g_iSpecialSignup[id] |= (1<<KICKER);	
			}
			case 2: g_iPlayerClass[id] = WIDERECEIVER;
			case 3: g_iPlayerClass[id] = WIDERECEIVER;
			case 4: g_iPlayerClass[id] = RUNNINGBACK;
		}
	}
}

CreateTournamentClassMenu()
{
	g_iTournamentClass = menu_create( "Choose Position:", "TournamentClassHandler" );
	new callback = menu_makecallback("TournamentItemCallback")
	
	new i, number[4];
	for(i=0;i<TOURNAMENT_PLAYERS;i++)
	{
		format(number, 3, "%i", i );
		menu_additem(g_iTournamentClass, "", number, 0, callback)
	}	

	menu_addblank(g_iTournamentClass, TOURNAMENT_PLAYERS);
	menu_additem(g_iTournamentClass, "Remove", "15", 0 );
	menu_additem(g_iTournamentClass, "Exit", "20", 0 );
	menu_setprop(g_iTournamentClass, MPROP_EXIT, MEXIT_NEVER);
}

public TournamentItemCallback(id,menu,item)
{
	if(item == MENU_EXIT)
		return ITEM_IGNORE;
		
	new team = get_user_team(id);
	if(team != 1 || team != 2)
		return ITEM_IGNORE;
		
	new info[64];
	if( g_iPlayerTournmanet[team][item] > 0 )
		format(info, 63, "\y%s \wNeeded", g_szTournament[item] );
	else
		format(info, 63,"\y%s \rFULL", g_szTournament[item] );	
		
	menu_item_setname(menu, item, info);
	return ITEM_IGNORE;
}
*/