

/*
Public_SwitchClass( team, class )
{
	new id, x, pteam, pclass;
	id = g_iSpecialTeam[team][class];
	new start = id;
	new bool:roundOnce;
	for(x=1;x<=MAX_PLAYERS;x++)
	{
		id++;
		if(id > g_iMaxplayers)
			id = 0;
		
		if(roundOnce)
		{
			new old = g_iSpecialTeam[team][class];
			if(old && old != id)
				Public_ResetPosition(old);
				
			if(class != CLASS_SAFETY)
			{
				id = Public_RandomSpecial(team);
			//RemoveSpecial(id, team);
			
				g_iSpecialTeam[team][class] = id;
				g_iPlayerCurrentClass[id] = class;
			}
			//client_print(0,print_chat,"Random ( Team: %i , Class: %i, PTeam: %i, ID: %i )", team, class, pteam, id );
			return id;	
		}
		
		if(id == start)
			roundOnce = true;
		
		pclass = g_iPlayerClass[id];
		if(pclass == 0)
			continue;
			
		pteam = g_iPlayerTeam[id];
		if(pteam != team)
			continue;
			
		if(g_bSkip[pteam][class])
		{
			g_bSkip[pteam][class] = false;
			continue;	
		}
		
		if( (pclass & (1<<class)) > 0 )
		{
			//client_print(0,print_chat,"SwitchClass ( Team: %i , Class: %i, PTeam: %i, ID: %i )", team, class, pteam, id );
			new old = g_iSpecialTeam[team][class];
			if(old && old != id)
				Public_ResetPosition(old);
		
			//RemoveSpecial(id, team);
			g_iPlayerCurrentClass[id] = class;
			g_iSpecialTeam[team][class] = id;
			break;
		}
	}
	
	return id;
}


Public_ResetPositionTeam( ignorePlayer, team )
{
	new id;
	
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if(id != ignorePlayer && g_iPlayerTeam[id] == team && g_iPlayerClass[id] != 0)
			Public_ResetPosition(id);
	}	
}

Public_ResetPosition( id )
{
	new pclass = g_iPlayerClass[id];
	new curclass = 0;
	if(pclass & (1<<CLASS_RECEIVER))
		curclass = CLASS_RECEIVER;
	else if(pclass & (1<<CLASS_RUNNINGBACK))
		curclass = CLASS_RUNNINGBACK;
	else if(pclass & (1<<CLASS_LINE_END))
		curclass = CLASS_LINE_END;
	else if(pclass & (1<<CLASS_LINEMAN))
		curclass = CLASS_LINEMAN;
		
	g_iPlayerCurrentClass[id] = curclass;
}

Public_RandomSpecial(team)
{
	new id, pteam;
	new plist[33], num;
	for(id=1;id<=g_iMaxplayers;id++)
	{
		if( is_user_connected(id) )
		{
			pteam = get_user_team(id);//g_iPlayerTeam[id];
			if(pteam == team && g_iPlayerClass[id] > 0 )
				plist[num++] = id;
		}
	}
	return plist[ random_num(0,num-1) ];
}
*/

Public_ChooseSpecial( team, class, bool:bIsEndPlay )
{
	//new ballteam = GetBallData(BALL_TEAM);
	new curspecial = GetCurrentSpecial(team, class);
	
	//static oldTeam = 0;
	static Float:oldYard = 0.0;
	static oldPlay = 0;
	static oldIntStat = -1;
	
	if(bIsEndPlay)
	{
		if(class == CLASS_SAFETY && g_iLastEvent != PENALTY_DELAYOFGAME)
			curspecial = ChangeSpecial(team, class);
		else if(class == CLASS_QUARTERBACK)
		{
			if( oldPlay == PLAY_STANDARD && 
				( 
					(g_flCurrentYard < (oldYard+PUBLIC_QB_MIN_YARDS) && g_iLastEvent != SCORE_TOUCHDOWN) ||
					(oldIntStat != -1 && oldIntStat != GetStat(curspecial, S_PASS_INTERCEPT)) ||
					(g_iLastEvent == PENALTY_DELAYOFGAME)
				)
				)
				curspecial = ChangeSpecial(team, class);
		}
		else if(class == CLASS_KICKER)
		{
			if(g_iLastEvent != SCORE_FIELDGOAL)
				curspecial = ChangeSpecial(team, class);	
		}
	}
	else
	{
		oldYard = g_flCurrentYard;
		oldPlay = g_iPlay;
		if(class == CLASS_QUARTERBACK)
		{
			oldIntStat = GetStat(curspecial, S_PASS_INTERCEPT);	
		}
		//oldTeam = ballteam;
		
		
		new i;
		if(curspecial == 0)
		{
			new spcnt = CountSpecialSignup(team,class);
			for(i=0;i<spcnt;i++)
				if(	(curspecial = ChangeSpecial(team,class)) != 0)
					break;
					
			if(class != CLASS_SAFETY && curspecial == 0)
			{
				new pteam, cnt, players[32];
				
				for(i=1;i<=g_iMaxplayers;i++)
				{
					if(!is_user_connected(i) || is_user_bot(i))
						continue;
					pteam = get_user_team(i);
					if(pteam == team)
						players[cnt++] = i;
				}	
				curspecial = players[random_num(0,cnt-1)];
			}
		}	
		
		new name[32];
		get_user_name(curspecial,name,31);
		if(class == CLASS_QUARTERBACK)
			client_print(0,print_chat,"%s is quarterback.", name );	
		else if(class == CLASS_KICKER)
			client_print(0,print_chat,"%s is kicker.", name );	
			
		SetCurrentSpecial( curspecial, team, class );
	}
		
	return curspecial;
}
Public_ChangeClass(id)
{
	if(g_iChoosingClass[id])
		return;
		
	new team = get_user_team(id);
	if(team != 1 && team != 2)
		return;

	g_iChoosingClass[id] = true;
	menu_display(id, g_iClassMenu, 0)	
}

CreatePublicClassMenu()
{
	//new i, number[4];
	g_iClassMenu = menu_create("Choose Class:", "ClassHandler")
	new callback = menu_makecallback("ClassItemCallback")
		
	menu_additem(g_iClassMenu, "Receiver", 		"1", 0, callback );
	menu_additem(g_iClassMenu, "Running Back", 	"2", 0, callback );
	menu_additem(g_iClassMenu, "Line Backer", 	"3", 0, callback );
	//menu_additem(g_iClassMenu, "Line Man", 		"4", 0, callback );
	
	menu_addblank(g_iClassMenu, 5);
	menu_additem(g_iClassMenu, "Skip", "-1", 0, callback );
	menu_setprop(g_iClassMenu, MPROP_EXIT, MEXIT_NEVER);
	//menu_setprop(g_iClassMenu, MPROP_EXIT, MEXIT_ALL);
}

CreatePublicSpecialMenu()
{
	new info[128]
	
	format(info, 127, "Special Class Choose:");
	g_iSpecialMenu = menu_create(info, "SpecialClassHandler");
	
	//new i, number[4];
	new callback = menu_makecallback("SpecialItemCallback");
	
	menu_additem(g_iSpecialMenu, "Quarterback", "7", 0, callback );
	menu_additem(g_iSpecialMenu, "Safety", 		"8", 0, callback );
	menu_additem(g_iSpecialMenu, "Kicker", 		"9", 0, callback );

	menu_addblank(g_iSpecialMenu, 4);
	//menu_addblank(g_iSpecialMenu, 5);
	menu_additem(g_iSpecialMenu, "Skip", "-1", 0 );
	//menu_setprop(g_iSpecialMenu, MPROP_EXIT, MEXIT_ALL);
	menu_setprop(g_iSpecialMenu, MPROP_EXIT, MEXIT_NEVER);	
}

public ClassItemCallback(id, menu, item)
{
	if(item == MENU_EXIT)
		return ITEM_IGNORE;
		
	new pclass = GetDefaultClass(id);//g_iPlayerClass[id];
	if(pclass > 0 && item == 3)
	{
		menu_item_setname(menu, item, "Skip");
		return ITEM_IGNORE;
	}
	
	if(item < 0 || item >= 3)
		return ITEM_IGNORE;
	
	new class = item + CLASS_RECEIVER;
	new info[128];
	new team = get_user_team(id);
	new count = CountClass(team,class);//GetClassCount( team, class );//GetCurClassCount( team, class );
	new maxcount = g_iMaxClassCount[class];
	new needed = maxcount - count;
	if(pclass == class)//pclass & (1<<class))
	{
		format(info, 127, "\r%s \r/ \r%s \r- \rCURRENT", g_szOffense[class], g_szDefense[class] );
	}
	else
	{
		if(needed > 0)
			format(info, 127, "\w%s \y/ \w%s \y- \w(\y%i\w/\r%i\w)", g_szOffense[class], g_szDefense[class], count, maxcount );
		else
			format(info, 127, "\r%s \r/ \r%s \r- \rFULL", g_szOffense[class], g_szDefense[class] );	
	}
		
	menu_item_setname(menu, item, info);
	return ITEM_IGNORE;
}

public SpecialItemCallback(id, menu, item)
{
	if(item < 0 || item > 3)
	{
		//client_print(id,print_chat, "Item = %i", item);
		return ITEM_IGNORE;
	}
		
	new info[128];
	new class = item + CLASS_QUARTERBACK;//g_iAltMenuOrder[item];
	//new team = get_user_team(id);//g_iPlayerTeam[id];
	//new cnt = GetClassCount(team,class);
	
	if(GetSignup(id,class))// & (1<<class))
		format(info, 127, "\r%s \w- \rRemove", g_szSpecial[item] );
	else
		format(info, 127, "\y%s \w- \ySign up", g_szSpecial[item] );
		
	menu_item_setname(menu, item, info);
	
	return ITEM_IGNORE;
}	

public ClassHandler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		if( is_user_connected(id) && GetClass(id) > 0 )
			ChooseSpecialClass(id);
		return;
	}
	
	if(is_user_connected(id)) {
		new cmd[6], iName[64];
		new access, callback;
		menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback); 
		
		new class = item + CLASS_RECEIVER;//;
		
		new team = get_user_team(id);
		if(team != 1 && team != 2)
			return;
			
		if(str_to_num(cmd) == -1)
		{
			//menu_destroy(menu);
			ChooseSpecialClass(id);
			return;	
		}
		
		new ballholder = GetBallData( BALL_HOLDER );
		if(ballholder == id)
		{
			client_print(id,print_chat, "You can't change class when you have ball!" );	
			return;
		}
		
		
	
		//g_iPlayerTeam[id];
		new needed = g_iMaxClassCount[class] - CountClass(team,class);
		new pclass = GetDefaultClass(id);
		
		if(needed > 0 && pclass != class )
		{
			SetClass( id, class );
			
			new currentClass = GetClass(id);
			if( currentClass < CLASS_QUARTERBACK )
			{
				Respawn(id);
				//currentClass -= CLASS_QUARTERBACK;
				//client_print(id,print_chat, "Can't change class while %s!", g_szSpecial[currentClass] );	
				//return;
			}
			
			
			//if(pclass == 0 || (id != GetBallData(BALL_HOLDER)))
			//	Respawn(id);
					
			ChooseSpecialClass(id);
		}
		else
		{
			cmdChangeClass(id);
			if(pclass == class)
				client_print(id,print_chat, "You are that class already!" );
			else
				client_print(id,print_chat, "Class is full!" );
			return;
		}
	}	
	
	g_iChoosingClass[id] = false;
}

public ChooseSpecialClass(id)
{
	menu_display(id, g_iSpecialMenu, 0)	
}

public SpecialClassHandler(id, menu, item)
{
	if(item == MENU_EXIT || item > 2 || item < 0)// || item < 0 || item > 2)
		return;
	if(is_user_connected(id)) {
		
		new cmd[6], iName[64];
		new access, callback;
		menu_item_getinfo(menu, item, access, cmd,5, iName, 63, callback); 
		
		new pspecial = item + CLASS_QUARTERBACK;
		new team = get_user_team(id);
		
		if(team != 1 && team != 2)
			return;
			
		if(GetSignup(id,pspecial))
		{
			/*
			if( GetClass(id) == pspecial )
			{
				client_print(id,print_chat, "Cannot remove yourself from %s while you are %s", g_szSpecial[item], g_szSpecial[item] );
				ChooseSpecialClass(id);
				return;	
			}
			*/
			new pclass = GetClass(id);
			if(pclass == pspecial)
			{
				client_print(id, print_chat, "Cannot remove while %s", g_szSpecial[item] );
			}
			else
			{
				RemovePlayer(id, team, pspecial);
				
				client_print(id, print_chat, "Removed from %s queue!", g_szSpecial[item] );
			}
		}
		else
		{
			AddPlayer( id, team, pspecial );
			client_print(id, print_chat, "Added to %s queue!",g_szSpecial[item] );
		}
		//menu_destroy(menu);
		ChooseSpecialClass(id);
	}	
}