#if defined _fb2_stocks
  #endinput
#endif
#define _fb2_stocks


public LastInv(id)
{
	client_cmd(id, "lastinv" );
	set_task(0.1, "LastInvDelay", id );	
}
public LastInvDelay(id)
{
	client_cmd(id, "lastinv");
}

StripAll()
{
	new i;
	for(i=1;i<=g_iMaxplayers;i++)
		if(is_user_alive(i))
		{
			strip_user_weapons(i);	
			g_iWeapon[i] = 0;
		}
}

GetBallMinMax( Float:mins[3], Float:maxs[3] )
{
	mins[0] = -5.0;	
	mins[1] = -5.0;	
	mins[2] = -10.0;
	
	maxs[0] =  5.0;	
	maxs[1] =  5.0;	
	maxs[2] = 10.0;
}

GetText_YardLine( yard, yardage[32] )
{
	//new yardage[32];
	new fakeyard = (yard>50?100-yard:yard);
	new teamBall = GetBallData( BALL_TEAM );
	if( (yard >= 50 && teamBall == T) || (yard <= 50 && teamBall == CT))
		format(yardage, 31, "Terrorist %i", fakeyard );
	else
		format(yardage, 31, "Counter-Terrorist %i", fakeyard );
}

//native ToggleDeath(id, death=-1);
ToggleDeath(id, death=-1)
{
	if(death == 0)
		g_bPlayerDied[id] = false;
	else if(death == 1)
		g_bPlayerDied[id] = true;	
		
	return g_bPlayerDied[id];
}

//native GetLastPlayerPos( id, Float:origin[3] );
public GetLastPlayerPos( id, Float:origin[3] )
{
	origin[0] = g_vPlayerPos[id][0];
	origin[1] = g_vPlayerPos[id][1];
	origin[2] = g_vPlayerPos[id][2];
}

GetFormation(id)
{
	new team = get_user_team(id);
	new startTeam = GetBallData( BALL_START_TEAM );
	
	if(g_iPlay == PLAY_KICKOFF)
	{
		if(startTeam == team)
			return KRETURN;
		else
			return KRECEIVE;	
	}
	
	if(g_iPlay == PLAY_STANDARD)
	{
		if(startTeam == team)
			return OFFENSE;
		else
			return DEFENSE;
	}
	
	if(g_iPlay == PLAY_PUNT)
	{
		if(startTeam == team)
			return PUNT;
		else
			return PUNTRETURN;	
	}
	
	if(g_iPlay == PLAY_FIELDGOAL)
	{
		if(startTeam == team)
			return FIELDGOAL;
		else
			return FIELDGOALBLOCK;	
	}
	return -1;
}



Give( id, const weapon[] )
{
	new weap = give_item( id, weapon );	
	
	if( weap > 0 && equal( weapon, "weapon_knife" )  )
	{
		g_iWeapon[id] = weap;
		
		set_pdata_float( id, 83, -0.001);
	}
	
}
/************************************\
 Respawns player after X seconds.
 
 Returns:
 Nothing
\************************************/
Respawn(id, Float:spawntime=0.0)
{
	if(id == 0)
	{
		for(id=1;id<=g_iMaxplayers;id++)
			if(GetDefaultClass(id) > 0)
				Respawn(id, random_float(0.0, 0.3));
		return;
	}
	
	if(!is_user_connected(id) || GetDefaultClass(id) == 0)
		return;

	set_task( spawntime, "TimedSpawn", id+34343 );
	
	//new Float:old = csdm_get_spawnwait();
	//csdm_set_spawnwait(spawntime);
	//csdm_respawn(id);
	//csdm_set_spawnwait(old);	
}

public TimedSpawn(id)
{
	id -= 34343;
	ExecuteHam( Ham_CS_RoundRespawn, id );
}

public randomize_teams()
{
	new terr, ct, id, team, cnt, temp, x, pl_temp
	new teams[3][33], player_list[33]
	new shuff_t, shuff_ct
	new shuffle = random_num(10,30)

	//Put all players in one big list
	for(id=1; id<=g_iMaxplayers; id++)
		if(is_user_connected(id) && !is_user_bot(id)) {
			team = get_user_team(id)
			if(team == 1 || team == 2)
				player_list[cnt++] = id
		}

	cnt--

	//Make a list of Terr and CT players
	while(cnt >= 0)
	{
		if(cnt % 2 == 0)
			teams[1][terr++] = player_list[cnt--]
		else
			teams[2][ct++] = player_list[cnt--]
	}

	//Shuffle the players
	for(x=0;x<=shuffle;x++) {
		shuff_t = random_num(0,terr-1);
		shuff_ct = random_num(0,ct-1);
		temp = teams[1][shuff_t];
		teams[1][shuff_t] = teams[2][shuff_ct];
		teams[2][shuff_ct] = temp;
	}

	//Put Players in their team.
	for(x=1; x<3; x++)
		for(id=0; id<((terr>ct?terr:ct)); id++) 
		{
			pl_temp = teams[x][id]
			if(is_user_connected(pl_temp)) 
			{
				//ResetPlayer(id);
				ClearPlayer(pl_temp);
				select_model(pl_temp, x, random_num(1,4))
				set_task(1.0, "DelayedTeamSwitch", pl_temp+(x*1000))
			}
		}
		
	//Respawn(0);
}

public DelayedTeamSwitch(id) {
	new team, msg[124]
	if(id >= 2000)
		team = 2
	else
		team = 1

	id -= team*1000

	if(!is_user_connected(id))
		return;
	
	user_kill(id);
	
	format(msg, 123, "^x03 You were switched to %s.", team==1?"Terrorist":"Counter-Terrorist")
	message_begin(MSG_ONE_UNRELIABLE, g_msgSayText, {0,0,0}, id)
	write_byte(id)
	write_string(msg)
	message_end()
	
	//Our Class Menu picker.
	cmdChangeClass(id);
}

//random model selecting for teamstack
select_model(id, team, model) {
	switch(team) {
		case 1: {
			switch(model) {
				case 1: cs_set_user_team(id, CS_TEAM_T, CS_T_TERROR)
				case 2: cs_set_user_team(id, CS_TEAM_T, CS_T_LEET)
				case 3:	cs_set_user_team(id, CS_TEAM_T, CS_T_ARCTIC)
				case 4: cs_set_user_team(id, CS_TEAM_T, CS_T_GUERILLA)
			}
		}
		case 2: {
			switch(model) {
				case 1: cs_set_user_team(id, CS_TEAM_CT, CS_CT_URBAN)
				case 2: cs_set_user_team(id, CS_TEAM_CT, CS_CT_GSG9)
				case 3: cs_set_user_team(id, CS_TEAM_CT, CS_CT_SAS)
				case 4: cs_set_user_team(id, CS_TEAM_CT, CS_CT_GIGN)
				case 5: cs_set_user_team(id, CS_TEAM_CT, CS_CT_VIP) //my lil secret
			}
		}
	}
}

/************************************\
 Convert Yardage to Origin Y value.
 
 Returns:
 Origin Y value of yard.
\************************************/
Float:GetOriginYard( Float:yard )
{
	if(GetBallData( BALL_TEAM ) == CT)
		return (g_vGoalLine[T] + (yard * g_flYardDist));
	
	return (g_vGoalLine[CT] - (yard * g_flYardDist));
}

/************************************\
 Get yard from Y origin position
 
 Returns:
 Yard line - 100 at touchdown 0 at safety
\************************************/
Float:GetYard( Float:yOrig )
{
	if(GetBallData( BALL_TEAM ) == CT)
		return ((yOrig - g_vGoalLine[T]) / g_flYardDist);
	
	return ((g_vGoalLine[CT] - yOrig) / g_flYardDist);
}

/************************************\
 Velocity Direction for team
 
 Returns:
 1  = team endzone
 -1 = enemy endzone
\*************************************/
stock CheckVelocityDirection( team, Float:vel[3] )
{
	new Float:velo[3];
	new Float:angle[3];
	velo[0] = vel[0];
	velo[1] = vel[1];
	vector_to_angle( velo, angle );
	return BallDirection( team, angle[1] );
}

/************************************\
 Player Direction to go for team
 
 Returns:
 1  = team endzone
 -1 = enemy endzone
\*************************************/
PlayerDirection( id )
{
	new team = get_user_team(id);
	new Float:angle[3];
	
	entity_get_vector( id, EV_VEC_angles, angle );
		
	new balldir = BallDirection( team, angle[1] );

	return balldir;
}

/************************************\
 Ball Direction for throwing
 
 Returns:
 1  = team endzone
 -1 = enemy endzone
\*************************************/
BallDirection( team, Float:angle_yaw )
{
	new balldir = _FORWARD;
	
	if(angle_yaw > 180.0)
		angle_yaw -= 360.0;
	
	//180 degree field of view for Forward direction
	if(team == T)
	{
		if(angle_yaw <= 0.0 && angle_yaw >= -180.0)
			balldir = _FORWARD;
		else
			balldir = _BACK;
	}
	else
	{
		if(angle_yaw >= 0.0 && angle_yaw <= 180.0)
			balldir = _FORWARD;
		else
			balldir = _BACK;
	}
		
	return balldir;
}

/************************************\
 Is Player on Ground
 
 Returns:
 true if on ground, false if not
\*************************************/
bool:on_ground(id) 
{	
	new flags = entity_get_int(id, EV_INT_flags)
	new movetype = entity_get_int(id,EV_INT_movetype)
	if( (movetype == 5) || (flags & FL_ONGROUND) || (flags & FL_PARTIALGROUND) || 
		(flags & FL_INWATER) || (flags & FL_CONVEYOR) || (flags & FL_FLOAT) )
			return true;
	return false;
}

bool:VectorEqual( Float:a[3], Float:b[3] )
	return (a[0] == b[0]  && a[1] == b[1] && a[2] == b[2]);
	
stock Float:GetDist( Float:a[3], Float:b[3] )
{
	new Float:x;
	new Float:y;
	x = a[0] - b[0];
	y = a[1] - b[1];
	return ( (x*x) + (y*y) );	
}